program font_test;

uses
	Windows,
	Messages,
	UDxApp;

const
	WM_IDLE            = (WM_USER + 100);
	CLASS_NAME : PChar = '__DX_FONT_TEST__';
	TITLE_NAME : PChar = 'Dx Font test';
	
var
	g_hWindow  : HWnd = 0;

function WindowProc(hWindow : HWnd; uMsg : UINT; wParam : WPARAM; lParam : LPARAM) : LRESULT; stdcall;
begin
	WindowProc := 0;

	case uMsg of
		WM_CREATE :
		begin
		end;
		WM_SHOWWINDOW :
		begin
		end;
		WM_DESTROY :
		begin
			PostQuitMessage(0);
			Exit;
		end;
		WM_IDLE :
		begin
			g_GameMain.Run();

			if (LoByte(GetAsyncKeyState(VK_ESCAPE)) > 0) then begin
				DestroyWindow(hWindow);
			end;

		end;
	end;

	WindowProc := DefWindowProc(hWindow, uMsg, wParam, lParam);
end;

function MyRegisterClass(hInstance : HINST) : ATOM;
var
	WinClass : TWNDCLASS;
begin
	FillChar(WinClass, sizeof(WinClass), 0);

	WinClass.style         := CS_HREDRAW or CS_VREDRAW;
	WinClass.lpfnWndProc   := @WindowProc;
	WinClass.cbClsExtra    := 0;
	WinClass.cbWndExtra    := 0;
	WinClass.hInstance     := hInstance;
	WinClass.hIcon         := LoadIcon(hInstance, 'smgal');
	WinClass.hCursor       := LoadCursor(0, IDC_ARROW);
	WinClass.hbrBackground := GetStockObject(LTGRAY_BRUSH);
	WinClass.lpszMenuName  := CLASS_NAME;
	WinClass.lpszClassName := CLASS_NAME;

	Result := RegisterClass(WinClass);
end;

function  WinMain : Integer;
var
	uMsg       : TMsg;
begin

	if HPrevInst = 0 then begin
		if MyRegisterClass(HInstance) = 0 then
			Halt;
	end;

	g_hWindow := CreateWindow(CLASS_NAME, TITLE_NAME,
							  WS_POPUP,
							  0, 0,
							  SCREEN_WIDTH,
							  SCREEN_HEIGHT,
							  0, 0, hInstance, nil);

	if g_hWindow = 0 then
		Halt;

	ShowWindow(g_hWindow, CmdShow);
	UpdateWindow(g_hWindow);

	g_GameMain := TGameMain.Create();
	g_GameMain.Init(g_hWindow, SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_DEPTH, TRUE);

	while (TRUE) do begin
		if PeekMessage(uMsg, 0, 0, 0, PM_NOREMOVE) then begin
			if not GetMessage(uMsg, 0, 0, 0) then
				break;
			TranslateMessage(uMsg);
			DispatchMessage(uMsg);
		end
		else begin
			PostMessage(g_hWindow, WM_IDLE, 0, 0);
			WaitMessage;
		end;
	end;

	g_GameMain.Done();

	Result := uMsg.wParam;
end;

begin
	Halt(WinMain);
end.

